#! /usr/bin/perl -w

# Launch MPI SELFE run and combine outputs along the way.
# Run on the run/ dir (i.e., one level above outputs/).
# Assume *_elev.61 is always output.
# Make sure to reserve 1 CPU on the current system for combining.

if(@ARGV != 4) 
{ 
  print "$0 <executible name> <# of processors> <machine list file> <total # of stacks> \n";
  exit(1);
}
$exect=$ARGV[0]; $np=$ARGV[1]; $mfile=$ARGV[2]; $stacks=$ARGV[3]; 

system "rm -rf outputs/; mkdir outputs";

if($stacks==1)
{
  $err= system "mpirun -np $np -machinefile $mfile $exect >& scrn.out ";
  if($err==0) {combine_outputs($current_stack);}
} 
else 
{
  if($pid = fork) #create child
  {
    #Parent process here
    $err= system "mpirun -np $np -machinefile $mfile $exect >& scrn.out";
    waitpid ($pid,0)
  }
  else #child process
  {
    defined($pid) or die "fork: $!";
    for($next_stack=2; $next_stack<=$stacks; $next_stack++)
    {
      while(!-e "outputs/$next_stack\_0000_elev.61") {sleep 300;} #sleep 5 min.
      $current_stack=$next_stack-1;
      combine_outputs($current_stack);
    } #for
    exit; #make sure to exit child process and return handle to parent
  }

  if($err == 0)
  {
    combine_outputs($stacks);
    #Clean up
    #system "cd outputs/; echo *_[0-9]???_*.6? | xargs rm -f";
  }
  else
  {print "Run did not succeed; check scrn.out!\n";}
}


sub combine_outputs{
# @_ is input list
  $start_day=$_[0];
  $end_day=$_[0];
# Echo inputs
  #print "$0 $start_day $end_day\n";

# Update location of code below.
  $code="/home/users/yinglong/SELFE/combine_output4";
  @vars=('elev.61','pres.61','airt.61','shum.61','srad.61','flsu.61','fllu.61','radu.61','radd.61','flux.61','evap.61','prcp.61','wind.62','wist.62','dahv.62','vert.63','temp.63','salt.63','conc.63','tdff.63','vdff.63','kine.63','mixl.63','zcor.63','hvel.64');

  foreach $var (@vars)
  {
    if(-e "outputs/$start_day\_0000_$var")
    {
      open(IN,">outputs/combine_output.in");
      print IN "$var\n $start_day $end_day\n";
      close(IN);
      system "cd outputs; $code";
      print "done combining $var in stack $start_day...\n";
    } #if -e
  } #foreach

} #combine_outputs
